#include <bits/stdc++.h>

using namespace std;

#define MAXN 200001
#define int long long

int t,n,k;
int a[MAXN];

int32_t main()
{
    cin>>t>>n>>k;
    for (int i=1;i<=n;i++) cin>>a[i];
    bool subtask1=true;
    for (int i=2;i<=n;i++)
    {
        if (a[i]!=a[1]) {subtask1=false;break;}
    }
    if (subtask1)
    {
        int current=0;
        for (int i=1;i<=n;i++)
        {
            if (a[i]>=current) current++;
            else current--;
        }
        if (current!=k) {cout<<"NE"<<endl;return 0;}
        cout<<"DA"<<endl;if (t==0) return 0;
        for (int i=1;i<=n;i++) cout<<i<<" ";
        cout<<endl;return 0;
    }
    return 0;
}